/*                                          << Comments start
 Basic Navigation Program                   << Comments go on
 Frankensteined from many sources           << Comments and on
 Works okay so far                          << Comments and on
*/                                          // Comments end
                                            // White space
#include "abdrive.h"                        // Include "abdrive.h"
#include "ping.h"                           // Include "ping.h"
#include "servodiffdrive.h"                 // Include "servodiffdrive.h"
#include "simpletools.h"                    // Include simpletools.h
                                            // White space
// Declare functions                        << Comment
int ctr_ping();                             // Declare function to aim Ping
int eval_dist();                            // Declare function to evaluate distance readings from Ping
int scan_ahead();                           // Declare function to scan forward
int turn_Bob();                             // Declare function to turn Bob
                                            // White space
//Declare global variables                  << Comment
int array_pos;
int counter1;                               // Declare "counter1" as integer
int delay;                                  // Declare "delay" as integer
int det_rng;                                // Declare "det_rng" as integer
int direction;
int distance;                               // Declare "distance" as integer
int ping_dist[5];                           // Declare "ping_dist" as 5 element array    
                                            // White space
// Assign variable values                   << Comment
int delay = 500;                            // Set "delay" to 0.25 second
int det_rng = 20;                           // Set "det_rng" to 35cm
                                            // White space
int main()                                  // Here we go!
{                                           // Curly opening thing
  ctr_ping();                               // Call Ping aiming function
  //drive_ramp(4, 4);                       // Don't worry about this for now
  drive_speed(64, 64);                      // Turn servos @ 64 TPS
    while(ping_cm(17) >= det_rng) pause(5); // Wait until object in range on pin 17
    drive_speed(0, 0);                      // Stop servos
    scan_ahead();                           // Call "scan_ahead"
    eval_dist();                            // Call "eval_dist"
    ctr_ping();                             // Center Ping after five sector scan
  //drive_goto(57, -53);                      // Two wheel pivot ~180 degrees
  drive_speed(0, 0);                        // Stop servos
  drive_speed(64, 64);                      // Turn servos @ 64 TPS
    while(ping_cm(17) >= det_rng) pause(5); // Wait until object in range on pin 17
    drive_speed(0, 0);                      // Stop servos
                                            // Placeholder for more nerdy stuff!    
  freqout(4, 1000, 3000);                   // Piezo Alert (Pin 4, 1 Sec,. 3KHz) 
  exit(0);                                  // Okay, we've had enough
}                                           // Curly closing thing. We be done!
                                            // White space
int ctr_ping()                              // Center Ping sensor
{                                           // Curly opening thing
    freqout(4, 1000, 500 );                 // Beep (Pin 4, 1 Sec., 0.5KHz)
    for ( int x = 0; x < 7; x++ ) {         // Loop 7 times to allow Ping servo to align
        servo_set(16, 1450);                // Rotate Ping forward (980 ~90 degrees, 1450 ~90 degrees)
        pause(50);                          // Pause 0.5 Second
}                                           // Curly closing thing
    servo_stop();                           // Stop Servo
return(0);                                  // Back to main 
}                                           // Curly closing thing
                                            // White space again
int scan_ahead()                            // Five sector scan
{                                           // Curly opening thing
servo_set(16, 625);                         // Turn servo 90 degrees right
   distance = ping_cm(17);                  // Retrieve data from Ping on pin 17
   ping_dist[0] = distance;                 // Assign full right distance to array element 0
 pause(delay);                              // Pause 0.5 Second
                                            // More whits space
 servo_set(16, 1050);                       // Turn servo 45 degrees right
   distance = ping_cm(17);                  // Retrieve data from Ping on pin 17
   ping_dist[1] = distance;                 // Assign half right distance to array element 1
 pause(delay);                              // Pause 0.5 Second   
                                            // Even more white space
 servo_set(16, 1450);                       // Turn servo full forward
   distance = ping_cm(17);                  // Retrieve data from Ping on pin 17
   ping_dist[2] = distance;                 // Assign full ahead distance to array element 2
 pause(delay);                              // Pause for "delay"
                                            // Much more white space
 servo_set(16, 1900);                       // Ture servo 45 degrees left
    distance = ping_cm(17);                 // Retrieve data from Ping on pin 17
    ping_dist[3] = distance;                // Assign half left distance to array element 3
 pause(delay);                              // Pause for "delay"   
                                            // Yup, more of it
servo_set(16, 2250);                        // Ture servo 90 degrees left
    distance = ping_cm(17);                 // Retrieve data from Ping on pin 17
    ping_dist[4] = distance;                // Assign full left distance to array element 4
 pause(delay);                              // Pause for "delay"   
                                            // Last of the white space... for now
return(0);                                  // Back to where we came from, wherever that was
}                                           // Curly closing thing
                                            // Just kidding...whits space again
int eval_dist()                             // Determine longest distance from Ping
{                                           // Curly opening thing
  int max_val;                              // Declare variable "max_val"
  int array_size = 5;                       // Assign value to 'array_size"
  int counter;                              // Declare "counter" as integer
  
  array_pos = 0;                            //
  max_val = ping_dist[0];                   // Initialize max_val to array position zero    
                                            //
  for (counter = 1; counter <= array_size; counter++)
  {                                         // Curly opening thing
    if (ping_dist[counter] > max_val)       //
    {                                       //
       max_val  = ping_dist[counter];       //
       array_pos = counter+1;               //
    }                                       //
}                                           //
                                            //
  turn_Bob();                               // Call "turn_Bob"
  return 0;                                 // Back to where we came from, wherever that was
}                                           //  
                                            //
int turn_Bob(){                             // Function to change Bob's direction of travel
    switch(array_pos - 1)                       //
    {                                       //
  case 0:                                           // Note the colon, not a semicolon
freqout(4, 1000, 3000);
    drive_goto(-28, 27);
    drive_speed(0, 0);                              // Stop servos
    break;

  case 1:
freqout(4, 1000, 3000);
    pause(delay);
freqout(4, 1000, 3000);                                             // Note the colon, not a semicolon
    drive_goto(14, -14);
    drive_speed(0, 0);                                 // Stop servos
    break;
    
  case 2:
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
    //drive_goto(64, 64);
    drive_speed(0, 0);                             // Stop servos
    break;
    
  case 3:
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
    drive_goto(14, -14);
    drive_speed(0, 0);                             // Stop servos
    break;    

  case 4:
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
pause(delay);    
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);    
pause(delay);                                          // Note the colon, not a semicolon
    drive_goto(28, -27);
    drive_speed(0, 0);                              // Stop servos
    break;

  default:
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);
pause(delay);    
    freqout(4, 1000, 3000);
pause(delay);                                          // Note the colon, not a semicolon
    freqout(4, 1000, 3000);
pause(delay);
    freqout(4, 1000, 3000);    
pause(delay);
    drive_goto(53, -57);
    drive_speed(0, 0);                              // Stop servos
    break;
    }
return(0);    
}    



